/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "../../../libs.h"
#include "../../../vn/conversation/talk.h"
#include "../../../display/animation/queue.h"
#include "../pokerdiscussion.h"
#include "round.h"
#include "action.h"

/** Callback fired when the game action first starts */
void _pokerGameActionStartOnStart(
  queue_t *queue, queueaction_t *action, uint8_t i
);

/** Callback fired when the game start action ends */
void _pokerGameActionStartOnEnd(queue_t *queue,queueaction_t *action,uint8_t i);

/**
 * Queues a match starting action onto the queue, also handles game logic for
 * speaking VN style.
 * 
 * @param game Game to add to.
 * @return The queued action.
 */
queueaction_t * pokerGameActionStartAdd(pokergame_t *game);