/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "../libs.h"
#include "../file/assetmanager.h"
#include "../engine/engine.h"
#include "../display/renderlist.h"
#include "../display/shader/shader.h"

typedef struct {
  engine_t *engine;
  assetmanagerowner_t assetOwner;
  renderlist_t renderList;
} scene_t;

void sceneInit(scene_t *scene, engine_t *engine);
void sceneRenderStart(scene_t *scene);
void sceneRenderEnd(scene_t *scene);
void sceneDispose(scene_t *scene);